#ifndef SHADOW_H_INCLUDED
#define SHADOW_H_INCLUDED

#ifndef FFS_WIN
header should be used in the windows build only!
#endif

#include "zstring.h"
#include "fileError.h"


namespace FreeFileSync
{
    class ShadowCopy //buffer access to Windows Volume Shadow Copy Service
    {
    public:
        ShadowCopy();
        ~ShadowCopy();

        Zstring makeShadowCopy(const Zstring& inputFile); //throw(FileError); returns filename on shadow copy

    private:
        bool isOkay();

        Zstring realVolumeLast;   //buffer last volume name
        Zstring shadowVolumeLast; //buffer last created shadow volume
        void* backupHandle;
    };
}

#endif // SHADOW_H_INCLUDED
